#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

red = Create_String(String, "red", (255, 0, 0))
red.Add_Sequence("11")

blue = Create_String(String, "blue", (120, 120, 255))
blue.Add_Sequence("01")

red = Create_Component(Light_Control, red)
blue = Create_Component(Light_Control, blue)
one = Create_Component(Stimulator_Simple, ST_ONE)
clock = Create_Component(Stimulator_Simple, ST_CLOCK)


Meta_Data(text = "Flashy Tree",
    image = "tree1",
    desc = "This time, you're lighting a Christmas tree!\n\nMake the "
        "blue lights flash while the red lights "
        "stay on constantly. The second power source (left) outputs a "
        "flashing signal.\n\n"
        "Hint: On any level where things are flashing, you may find it helpful "
        "to change the speed using the 'Speed Control' on the right. When "
        "the speed control is set to 0, you can press 'Step' to advance by "
        "one cycle.",
    guide = [
    Guide(trigger = "blue.Get_State() == ST_UNDEFINED",
        point_at = "clock.Get_Terminal()",
        text = "Point the mouse here and hold the left button down."),
    Guide(trigger = "(n.Is_Placing_Wire() and (s == clock.Get_Terminal()))",
        point_at = "blue.Get_Terminal()",
        text = "You're placing a 'Wire'. Drag the line to the terminal "
            "attached to the blue lights."),
    Guide(trigger = "((red.Get_State() == ST_UNDEFINED) "
                        "and (blue in clock.provides))",
        point_at = "None",
        text = "The blue lights are now flashing! Now link the red lights "
            "to the steady (non-flashing) power source to complete the "
            "level!"),
    ])

