#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

white = Create_String(String, "white", colour = (255, 255, 255),
            image_name = "whitestar", 
            image_pos = [(50, 50), (250, 50), (150, 150), 
                        (50, 250), (250, 250)])
white.Add_Sequence("10")

blue = Create_String(String, "blue", colour = (120, 120, 255),
            image_name = "bluestar", 
            image_pos = [(150, 50), (50, 150), (250, 150), (150, 250)])
blue.Add_Sequence("01")

blue = Create_Component(Light_Control, blue)
white = Create_Component(Light_Control, white)
clock = Create_Component(Stimulator_Simple, ST_CLOCK)
notgate = Create_Component(Not_Gate)


Meta_Data(text = "Two Tone",
    desc = "Here, you need to arrange for the white and blue stars to "
        "flash alternately. To do that you'll need to use a new component "
        "known as 'Not'.\n\n"
        "Hint: 'Not' has an input terminal on the left, and an output "
        "terminal on the right. The output value is the opposite of the "
        "input.",
    guide = [
    Guide(trigger = "True",
        point_at = "notgate",
        requires_ack = True,
        text = "You have two sets of lights, and one must be Off whenever "
            "the other is On. The component that arranges this for you is "
            "named 'Not'. The output of 'Not' is always the opposite of its "
            "input. You can see 'Not' in the middle of the screen. "
            "Click 'Next...' when ready."),
    Guide(trigger = "not (notgate in clock.provides)",
        point_at = "clock.Get_Terminal()",
        text = "Begin by connecting the flashing signal to the input of the "
            "'Not' component."),
    Guide(trigger = "((notgate in clock.provides) "
                "and not (white in notgate.provides))",
        point_at = "white.Get_Terminal()",
        text = "Notice how the input and output of 'Not' are already "
            "flashing alternately. Connect the output of 'Not' to the "
            "white terminal."),
    Guide(trigger = "((notgate in clock.provides) "
                "and (white in notgate.provides))",
        point_at = "clock.Get_Terminal()",
        text = "Complete the level by connecting the flashing "
            "input directly to "
            "the blue terminal."),
    ])

