#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

(one, two) = Gen_Binary(Create_String)

one.Add_Sequence("0101")
two.Add_Sequence("0011")

Create_Component(Light_Control, one)
Create_Component(Light_Control, two)

power = Create_Component(Stimulator_Simple, ST_ONE)

n1 = Create_Component(Not_Gate)
d1 = Create_Component(D_Flip_Flop)
d2 = Create_Component(D_Flip_Flop)
n2 = Create_Component(Not_Gate)



Meta_Data(text = "Generator",
    desc = "On this level, there are two lights named 'One' and 'Two'. "
        "You need to make these lights count from zero to three in base 2, "
        "that is, 00, 01, 10, 11.\n\n"
        "To do this, you'll need to build a 'sequence generator'. The Guide "
        "will lead you through the process.",
    dis_inputs = True,
    guide = [
    Guide(trigger = "True",
        point_at = "d1",
        text = "Link the output of this Delay component to the 'ce' input "
            "of the other Delay component."),
    Guide(trigger = "Mix_Tool([d2], [d1], 1)",
        point_at = "d1",
        text = "Now connect the 'ce' input of this Delay component to "
            "the power input."),
    Guide(trigger = "Mix_Tool([d2], [d1], 1) and Mix_Tool([d1], [power], 1)",
        point_at = "None",
        text = "Connect the output of each Delay component to its own 'd' "
            "input via a Not component."),
    Guide(trigger = "(len(n1.provides) != 0) and (len(n2.provides) != 0)",
        point_at = "None",
        text = "Now connect the output of each "
            "Delay component to a light. This completes the "
            "sequence generator. Notice that the sequence generator is "
            "producing the sequence 00, 01, 10, 11: zero to three in base 2.")
    ])

