#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

(santa, merry, christmas) = Gen_SMC(Create_String)

santa.Add_Sequence("01110001")
merry.Add_Sequence("00110011")
christmas.Add_Sequence("00010111")

Create_Component(Light_Control, santa)
Create_Component(Light_Control, merry)
Create_Component(Light_Control, christmas)

clockA = Create_Component(Stimulator, "Santa'", "0111")
clockB = Create_Component(Stimulator, "Mry'", "0011")
clockC = Create_Component(Stimulator, "Xms'", "0001")

Create_Component(And_Gate)
Create_Component(Or_Gate)
Create_Component(And_Gate)
Create_Component(Or_Gate)
Gap()
Create_Component(D_Flip_Flop)
Create_Component(Not_Gate)



Meta_Data(text = "Up, And Down",
    desc = "The input for this level is the output of the previous one: "
        "the three lights, 'Santa', 'Merry' and 'Christmas'. What you "
        "must do is extend the previous sequence.\n\n"
        "Arrange components so that all three lights begin in "
        "the 'Off' state, and then "
        "switch on in the following order: 'Santa', 'Merry' and 'Christmas'. "
        "After that, the lights must turn off again, and come "
        "on in the opposite "
        "order: 'Christmas', 'Merry' then 'Santa'.\n\n"
        "Hint: The roles of 'Christmas' and 'Santa' are reversed in the "
        "second phase of the sequence. You should solve this level by "
        "arranging for a Delay component to change state at the end of "
        "the original sequence (e.g. when the Xms input is On). "
        "Then use the output of that Delay component to switch the "
        "roles of the lights in the second phase.")

