#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

R = Create_String(String, "red", (255, 0, 0))
R.Add_Sequence("1100")
G = Create_String(String, "green", (0, 255, 0))
G.Add_Sequence("0110")
B = Create_String(String, "blue", (120, 120, 255))
B.Add_Sequence("0011")
Y = Create_String(String, "yellow", (255, 255, 0))
Y.Add_Sequence("1001")

Create_Component(Light_Control, R)
Create_Component(Light_Control, G)
Create_Component(Light_Control, B)
Create_Component(Light_Control, Y)

Create_Component(Stimulator_Simple, ST_ONE)

Create_Component(D_Flip_Flop)
Create_Component(Not_Gate)
Create_Component(D_Flip_Flop)
Create_Component(Not_Gate)
Create_Component(Xor_Gate)
Create_Component(Not_Gate)




Meta_Data(text = "Exclusive!",
    image = "tree1",
    dis_inputs = True,
    desc = "Activate the red, green, blue and yellow lights in turn. "
        "Each light should stay on for two cycles.\n\n"
        "This level introduces a fifth component: Exclusive Or (X). "
        "'Exclusive Or' has two inputs and one output, and that output is "
        "On if exactly one of the inputs is On. That's different to 'Or', "
        "where the output is On if either or both of the inputs is On. "
        "Exclusive Or is equivalent to a combination of several other "
        "components: in fact, the level named 'Re-generator' forced you "
        "to build one from two Ands, an Or and a Not.")

